;
; AssemblerApplication1.asm
;
; Created: 07.04.2023 15:00:00
; Author : Vladimir
;

.equ	FDIV10   = 6 ;Fclk divisor
.equ	FDIV20   = 3 ;Fclk divisor
.equ	FDIV15   = 4 ;Fclk divisor

.def	temp	= r16

	ldi	temp,(1<<PB1) ;PB1 - output (OC0B)
	out	DDRB,temp
	ldi	temp,(1<<PB0) | (1<<PB2) ;PB0,PB2 - inputs, pullups ON
	out	PORTB,temp

	ldi	temp,(1<<COM0B1) | (1<<COM0B0) | (1<<WGM01) | (1<<WGM00)
	out	TCCR0A,temp
	ldi	temp,(1<<WGM02) | (1<<CS00)
	out	TCCR0B,temp
Main:
	ldi	temp,FDIV10 - 1
	sbis	PINB,PB0
	ldi	temp,FDIV20 - 1
	sbis	PINB,PB2
	ldi	temp,FDIV15 - 1
	out	OCR0A,temp

	ldi	temp,(FDIV10 - 1) / 2
	sbis	PINB,PB0
	ldi	temp,(FDIV20 - 1) / 2
	sbis	PINB,PB2
	ldi	temp,(FDIV15 - 1) / 2
	out	OCR0B,temp

	rjmp 	Main ;Loop
